Prime Path

算法:BFS

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

思路:简单的广搜(BFS):有两个四位数的数素数n和m,问你每次只能将n的一位数变化,最少要变多说次变为m,如果做不到,就输出Impossible,否则输出最少操作次数

代码:

#include <iostream>
#include <cstring>
#include <iomanip>
#include <algorithm>
#include <string>
#include <cmath>
#include <stdio.h>
#include <queue>
using namespace std;
int a[10005],n,m,k;//a[]用来标记
struct dot
{
	int x,step;
};
int prime(int y)
{
	int i,j=0;
	for(i=2;i*i<=y;i++)
	{
		if(y%i==0) 
		{
			j=1; break;
		}
	}
	if(j==0)
	return 1;
	else return 0;
}
void bfs(int dx,int dy)
{   memset(a,0,sizeof(a));
	queue<dot>que;
	dot cur,loer;
	cur.x=dx;
	cur.step=0;
	a[dx]=1;
	que.push(cur);
	while(que.size())
	{   int s;
		loer=que.front();
		que.pop();
		int qw=loer.x;
		if(qw==dy) 
		{   k=1;
			cout<<loer.step<<endl;
			break;
		}
		for(int i=1;i<=9;i=i+2)//变个位 
		{   s=qw/10*10;
		    int q;
		    q=s+i; 
		    if(!a[q]&&prime(q))
		    {   a[q]=1;
		    	cur.x=q;
		    	cur.step=loer.step+1;
		    	que.push(cur);
			}
			
		} 
	    
		for(int i=0;i<10;i++)//变十位 
		{  int q;
		   s=qw%10;
	       int pp=qw/100*100;
		   q=pp+i*10+s;
		   if(!a[q]&&prime(q))
		   {   a[q]=1;
		       cur.x=q;
			   cur.step=loer.step+1;
			   que.push(cur);	
		   }  
		}
		
		for(int i=0;i<10;i++)//变百位 
		{
			int q;
			s=qw%100;
		    int pp=loer.x/1000*1000;
			q=pp+i*100+s;
			if(!a[q]&&prime(q))
		    {  a[q]=1;
		       cur.x=q;
			   cur.step=loer.step+1;
			   que.push(cur);	
		    }  
		}
	
		for(int i=1;i<=9;i++)//变千位 
		{
			int q;	
			s=qw%1000;
			q=s+i*1000;
			if(!a[q]&&prime(q))
		    {  a[q]=1;
		       cur.x=q;
			   cur.step=loer.step+1;
			   que.push(cur);	
		    }  
		} 
	}
}
int main()
{
	int t,i,j;
	cin>>t;
	while(t--)
	{   
		cin>>n>>m;
        k=0;
		bfs(n,m);
		if(k==0) cout<<"Impossible"<<endl;
	}
	return 0;
}


posted @ 2016-01-03 12:24  (慎独)  阅读(175)  评论(0编辑  收藏  举报